import { __awaiter, __rest } from 'tslib';
import { Component, ElementRef } from '@angular/core';
import { By } from '@angular/platform-browser';
import { TestBed } from '@angular/core/testing';
import { fireEvent, prettyDOM, getQueriesForElement } from 'dom-testing-library';
export { configure, createEvent, debugDOM, findAllByAltText, findAllByDisplayValue, findAllByLabelText, findAllByPlaceholderText, findAllByRole, findAllByTestId, findAllByText, findAllByTitle, findByAltText, findByDisplayValue, findByLabelText, findByPlaceholderText, findByRole, findByTestId, findByText, findByTitle, fireEvent, getAllByAltText, getAllByDisplayValue, getAllByLabelText, getAllByPlaceholderText, getAllByRole, getAllByTestId, getAllByText, getAllByTitle, getByAltText, getByDisplayValue, getByLabelText, getByPlaceholderText, getByRole, getByTestId, getByText, getByTitle, getDefaultNormalizer, getElementError, getNodeText, getQueriesForElement, prettyDOM, queries, queryAllByAltText, queryAllByAttribute, queryAllByDisplayValue, queryAllByLabelText, queryAllByPlaceholderText, queryAllByRole, queryAllByTestId, queryAllByText, queryAllByTitle, queryByAltText, queryByAttribute, queryByDisplayValue, queryByLabelText, queryByPlaceholderText, queryByRole, queryByTestId, queryByText, queryByTitle, queryHelpers, wait, waitForDomChange, waitForElement, waitForElementToBeRemoved, within } from 'dom-testing-library';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class WrapperComponent {
    /**
     * @param {?} elemtRef
     */
    constructor(elemtRef) {
        this.elemtRef = elemtRef;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.elemtRef.nativeElement.removeAttribute('ng-version');
    }
}
WrapperComponent.decorators = [
    { type: Component, args: [{ selector: 'wrapper-component', template: '' }] }
];
/** @nocollapse */
WrapperComponent.ctorParameters = () => [
    { type: ElementRef }
];
/**
 * @template T
 * @param {?} templateOrComponent
 * @param {?} __1
 * @return {?}
 */
function render(templateOrComponent, { detectChanges = true, declarations = [], imports = [], providers = [], schemas = [], queries, wrapper = WrapperComponent, componentProperties = {}, }) {
    return __awaiter(this, void 0, void 0, function* () {
        /** @type {?} */
        const isTemplate = typeof templateOrComponent === 'string';
        /** @type {?} */
        const componentDeclarations = isTemplate ? [wrapper] : [templateOrComponent];
        TestBed.configureTestingModule({
            declarations: [...declarations, ...componentDeclarations],
            imports: [...imports],
            schemas: [...schemas],
        });
        if (providers) {
            // override services this way to have the service overridden at the component level
            providers.forEach((/**
             * @param {?} p
             * @return {?}
             */
            p => {
                const { provide } = p, provider = __rest(p, ["provide"]);
                TestBed.overrideProvider(provide, provider);
            }));
        }
        /** @type {?} */
        const fixture = isTemplate
            ? createWrapperComponentFixture((/** @type {?} */ (templateOrComponent)), { wrapper, componentProperties })
            : createComponentFixture((/** @type {?} */ (templateOrComponent)), { componentProperties });
        yield TestBed.compileComponents();
        if (detectChanges) {
            fixture.detectChanges();
        }
        /** @type {?} */
        const eventsWithDetectChanges = Object.keys(fireEvent).reduce((/**
         * @param {?} events
         * @param {?} key
         * @return {?}
         */
        (events, key) => {
            events[key] = (/**
             * @param {?} element
             * @param {?=} options
             * @return {?}
             */
            (element, options) => {
                /** @type {?} */
                const result = fireEvent[key](element, options);
                fixture.detectChanges();
                return result;
            });
            return events;
        }), (/** @type {?} */ ({})));
        return (/** @type {?} */ (Object.assign({ fixture, container: fixture.nativeElement, debug: (/**
             * @param {?=} element
             * @return {?}
             */
            (element = fixture.nativeElement) => console.log(prettyDOM(element))) }, getQueriesForElement(fixture.nativeElement, queries), eventsWithDetectChanges)));
    });
}
/**
 * Creates the wrapper component and sets its the template to the to-be-tested component
 * @template T
 * @param {?} template
 * @param {?} __1
 * @return {?}
 */
function createWrapperComponentFixture(template, { wrapper, componentProperties, }) {
    TestBed.overrideComponent(wrapper, {
        set: {
            template: template,
        },
    });
    /** @type {?} */
    const fixture = TestBed.createComponent(wrapper);
    // get the component selector, e.g. <foo color="green"> and <foo> results in foo
    /** @type {?} */
    const componentSelector = template.match(/\<(.*?)\ /) || template.match(/\<(.*?)\>/);
    if (!componentSelector) {
        throw Error(`Template ${template} is not valid.`);
    }
    /** @type {?} */
    const sut = fixture.debugElement.query(By.css(componentSelector[1]));
    setComponentProperties(sut, { componentProperties });
    return fixture;
}
/**
 * Creates the components and sets its properties
 * @template T
 * @param {?} component
 * @param {?} __1
 * @return {?}
 */
function createComponentFixture(component, { componentProperties = {}, }) {
    /** @type {?} */
    const fixture = TestBed.createComponent(component);
    setComponentProperties(fixture, { componentProperties });
    return fixture;
}
/**
 * Set the component properties
 * @template T
 * @param {?} fixture
 * @param {?} __1
 * @return {?}
 */
function setComponentProperties(fixture, { componentProperties = {}, }) {
    for (const key of Object.keys(componentProperties)) {
        fixture.componentInstance[key] = componentProperties[key];
    }
    return fixture;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { render };
//# sourceMappingURL=angular-extensions-testing-library.js.map
