import { __awaiter, __generator, __spread, __rest, __assign, __values } from 'tslib';
import { Component, ElementRef } from '@angular/core';
import { By } from '@angular/platform-browser';
import { TestBed } from '@angular/core/testing';
import { fireEvent, prettyDOM, getQueriesForElement } from 'dom-testing-library';
export { configure, createEvent, debugDOM, findAllByAltText, findAllByDisplayValue, findAllByLabelText, findAllByPlaceholderText, findAllByRole, findAllByTestId, findAllByText, findAllByTitle, findByAltText, findByDisplayValue, findByLabelText, findByPlaceholderText, findByRole, findByTestId, findByText, findByTitle, fireEvent, getAllByAltText, getAllByDisplayValue, getAllByLabelText, getAllByPlaceholderText, getAllByRole, getAllByTestId, getAllByText, getAllByTitle, getByAltText, getByDisplayValue, getByLabelText, getByPlaceholderText, getByRole, getByTestId, getByText, getByTitle, getDefaultNormalizer, getElementError, getNodeText, getQueriesForElement, prettyDOM, queries, queryAllByAltText, queryAllByAttribute, queryAllByDisplayValue, queryAllByLabelText, queryAllByPlaceholderText, queryAllByRole, queryAllByTestId, queryAllByText, queryAllByTitle, queryByAltText, queryByAttribute, queryByDisplayValue, queryByLabelText, queryByPlaceholderText, queryByRole, queryByTestId, queryByText, queryByTitle, queryHelpers, wait, waitForDomChange, waitForElement, waitForElementToBeRemoved, within } from 'dom-testing-library';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var WrapperComponent = /** @class */ (function () {
    function WrapperComponent(elemtRef) {
        this.elemtRef = elemtRef;
    }
    /**
     * @return {?}
     */
    WrapperComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.elemtRef.nativeElement.removeAttribute('ng-version');
    };
    WrapperComponent.decorators = [
        { type: Component, args: [{ selector: 'wrapper-component', template: '' }] }
    ];
    /** @nocollapse */
    WrapperComponent.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    return WrapperComponent;
}());
/**
 * @template T
 * @param {?} templateOrComponent
 * @param {?} __1
 * @return {?}
 */
function render(templateOrComponent, _a) {
    var _b = _a.detectChanges, detectChanges = _b === void 0 ? true : _b, _c = _a.declarations, declarations = _c === void 0 ? [] : _c, _d = _a.imports, imports = _d === void 0 ? [] : _d, _e = _a.providers, providers = _e === void 0 ? [] : _e, _f = _a.schemas, schemas = _f === void 0 ? [] : _f, queries = _a.queries, _g = _a.wrapper, wrapper = _g === void 0 ? WrapperComponent : _g, _h = _a.componentProperties, componentProperties = _h === void 0 ? {} : _h;
    return __awaiter(this, void 0, void 0, function () {
        var isTemplate, componentDeclarations, fixture, eventsWithDetectChanges;
        return __generator(this, function (_j) {
            switch (_j.label) {
                case 0:
                    isTemplate = typeof templateOrComponent === 'string';
                    componentDeclarations = isTemplate ? [wrapper] : [templateOrComponent];
                    TestBed.configureTestingModule({
                        declarations: __spread(declarations, componentDeclarations),
                        imports: __spread(imports),
                        schemas: __spread(schemas),
                    });
                    if (providers) {
                        // override services this way to have the service overridden at the component level
                        providers.forEach((/**
                         * @param {?} p
                         * @return {?}
                         */
                        function (p) {
                            var provide = p.provide, provider = __rest(p, ["provide"]);
                            TestBed.overrideProvider(provide, provider);
                        }));
                    }
                    fixture = isTemplate
                        ? createWrapperComponentFixture((/** @type {?} */ (templateOrComponent)), { wrapper: wrapper, componentProperties: componentProperties })
                        : createComponentFixture((/** @type {?} */ (templateOrComponent)), { componentProperties: componentProperties });
                    return [4 /*yield*/, TestBed.compileComponents()];
                case 1:
                    _j.sent();
                    if (detectChanges) {
                        fixture.detectChanges();
                    }
                    eventsWithDetectChanges = Object.keys(fireEvent).reduce((/**
                     * @param {?} events
                     * @param {?} key
                     * @return {?}
                     */
                    function (events, key) {
                        events[key] = (/**
                         * @param {?} element
                         * @param {?=} options
                         * @return {?}
                         */
                        function (element, options) {
                            /** @type {?} */
                            var result = fireEvent[key](element, options);
                            fixture.detectChanges();
                            return result;
                        });
                        return events;
                    }), (/** @type {?} */ ({})));
                    return [2 /*return*/, (/** @type {?} */ (__assign({ fixture: fixture, container: fixture.nativeElement, debug: (/**
                             * @param {?=} element
                             * @return {?}
                             */
                            function (element) {
                                if (element === void 0) { element = fixture.nativeElement; }
                                return console.log(prettyDOM(element));
                            }) }, getQueriesForElement(fixture.nativeElement, queries), eventsWithDetectChanges)))];
            }
        });
    });
}
/**
 * Creates the wrapper component and sets its the template to the to-be-tested component
 * @template T
 * @param {?} template
 * @param {?} __1
 * @return {?}
 */
function createWrapperComponentFixture(template, _a) {
    var wrapper = _a.wrapper, componentProperties = _a.componentProperties;
    TestBed.overrideComponent(wrapper, {
        set: {
            template: template,
        },
    });
    /** @type {?} */
    var fixture = TestBed.createComponent(wrapper);
    // get the component selector, e.g. <foo color="green"> and <foo> results in foo
    /** @type {?} */
    var componentSelector = template.match(/\<(.*?)\ /) || template.match(/\<(.*?)\>/);
    if (!componentSelector) {
        throw Error("Template " + template + " is not valid.");
    }
    /** @type {?} */
    var sut = fixture.debugElement.query(By.css(componentSelector[1]));
    setComponentProperties(sut, { componentProperties: componentProperties });
    return fixture;
}
/**
 * Creates the components and sets its properties
 * @template T
 * @param {?} component
 * @param {?} __1
 * @return {?}
 */
function createComponentFixture(component, _a) {
    var _b = _a.componentProperties, componentProperties = _b === void 0 ? {} : _b;
    /** @type {?} */
    var fixture = TestBed.createComponent(component);
    setComponentProperties(fixture, { componentProperties: componentProperties });
    return fixture;
}
/**
 * Set the component properties
 * @template T
 * @param {?} fixture
 * @param {?} __1
 * @return {?}
 */
function setComponentProperties(fixture, _a) {
    var e_1, _b;
    var _c = _a.componentProperties, componentProperties = _c === void 0 ? {} : _c;
    try {
        for (var _d = __values(Object.keys(componentProperties)), _e = _d.next(); !_e.done; _e = _d.next()) {
            var key = _e.value;
            fixture.componentInstance[key] = componentProperties[key];
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return fixture;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { render };
//# sourceMappingURL=angular-extensions-testing-library.js.map
