"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tasks_1 = require("@angular-devkit/schematics/tasks");
var path = require("path");
function createRule(ruleName) {
    var _a;
    return new tasks_1.TslintFixTask({
        rulesDirectory: path.join(__dirname, 'rules'),
        rules: (_a = {},
            _a[ruleName] = [true],
            _a),
    }, {
        includes: ['**/*.spec.ts', '**/*.test.ts'],
        silent: false,
    });
}
function default_1() {
    return function (_, context) {
        var noCreateComponentRule = createRule('no-create-component');
        var noComponentParametersRule = createRule('no-component-parameters');
        var noComponentPropertyRule = createRule('no-component-property');
        var noCreateComponentRuleId = context.addTask(noCreateComponentRule);
        var noComponentParametersRuleId = context.addTask(noComponentParametersRule, [noCreateComponentRuleId]);
        context.addTask(noComponentPropertyRule, [noComponentParametersRuleId]);
    };
}
exports.default = default_1;
//# sourceMappingURL=index.js.map