"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var tslint_1 = require("tslint");
var tsquery_1 = require("@phenomnomnominal/tsquery");
var IS_COMPONENT_PROPERTY_QUERY = 'CallExpression:has(Identifier[name="render"]) > ObjectLiteralExpression:first-child';
var RENDER_OPTIONS_QUERY = 'CallExpression:has(Identifier[name="render"]) > ObjectLiteralExpression:last-child';
var COMPONENT_PARAMETERS_PROPERTY_VALUE_QUERY = 'PropertyAssignment:has(Identifier[name="parameters"]) :last-child';
var FAILURE_MESSAGE = 'Found `parameters` parameter, use `componentProperties` instead.';
var Rule = (function (_super) {
    __extends(Rule, _super);
    function Rule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Rule.prototype.apply = function (ast) {
        var _this = this;
        return tsquery_1.tsquery(ast, IS_COMPONENT_PROPERTY_QUERY)
            .map(function (result) {
            var parameterNode = tsquery_1.tsquery(result, COMPONENT_PARAMETERS_PROPERTY_VALUE_QUERY)[0];
            if (!parameterNode) {
                return [];
            }
            var renderOptionsNode = tsquery_1.tsquery(ast, RENDER_OPTIONS_QUERY)[0];
            var renderOptionsText = renderOptionsNode.getFullText();
            var bracketIndex = renderOptionsText.indexOf('{');
            var renderOptions = renderOptionsText.substring(0, bracketIndex + 1) +
                ("componentProperties:" + parameterNode.getFullText() + ",") +
                renderOptionsText.substr(bracketIndex + 1);
            var replacement = new tslint_1.Replacement(renderOptionsNode.getStart(), renderOptionsNode.getWidth(), renderOptions);
            var start = renderOptionsNode.getStart();
            var end = renderOptionsNode.getEnd();
            var replacementOriginal = new tslint_1.Replacement(parameterNode.getStart(), parameterNode.getWidth(), '');
            var startOriginal = renderOptionsNode.getStart();
            var endOriginal = renderOptionsNode.getEnd();
            return [
                new tslint_1.RuleFailure(ast, startOriginal, endOriginal, FAILURE_MESSAGE, _this.ruleName, replacementOriginal),
                new tslint_1.RuleFailure(ast, start, end, FAILURE_MESSAGE, _this.ruleName, replacement),
            ];
        })
            .reduce(function (rules, rule) { return rules.concat(rule); }, []);
    };
    return Rule;
}(tslint_1.Rules.AbstractRule));
exports.Rule = Rule;
//# sourceMappingURL=noComponentParametersRule.js.map