"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var tslint_1 = require("tslint");
var tsquery_1 = require("@phenomnomnominal/tsquery");
var IS_COMPONENT_PROPERTY_QUERY = 'CallExpression:has(Identifier[name="render"]) > ObjectLiteralExpression:first-child';
var COMPONENT_PROPERTY_VALUE_QUERY = 'PropertyAssignment:has(Identifier[name="component"]) :last-child';
var FAILURE_MESSAGE = 'Found component propety syntax, signature looks different.';
var Rule = (function (_super) {
    __extends(Rule, _super);
    function Rule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Rule.prototype.apply = function (ast) {
        var _this = this;
        return tsquery_1.tsquery(ast, IS_COMPONENT_PROPERTY_QUERY).map(function (result) {
            var valueNode = tsquery_1.tsquery(result, COMPONENT_PROPERTY_VALUE_QUERY)[0];
            var replacement = new tslint_1.Replacement(result.getStart(), result.getWidth(), (valueNode || result).text);
            var start = result.getStart();
            var end = result.getEnd();
            return new tslint_1.RuleFailure(ast, start, end, FAILURE_MESSAGE, _this.ruleName, replacement);
        });
    };
    return Rule;
}(tslint_1.Rules.AbstractRule));
exports.Rule = Rule;
//# sourceMappingURL=noComponentPropertyRule.js.map