"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var tslint_1 = require("tslint");
var tsquery_1 = require("@phenomnomnominal/tsquery");
var CREATE_COMPONENT_IDENTIFIER = 'Identifier[name="createComponent"]';
var CREATE_COMPONENT_IMPORT_QUERY = "ImportSpecifier > " + CREATE_COMPONENT_IDENTIFIER;
var CREATE_COMPONENT_CALL_EXPRESSION_QUERY = "CallExpression > " + CREATE_COMPONENT_IDENTIFIER;
var RENDER = 'render';
var FAILURE_MESSAGE = 'Found `createComponent`, use `render` instead.';
var Rule = (function (_super) {
    __extends(Rule, _super);
    function Rule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Rule.prototype.apply = function (ast) {
        var imports = this.getImports(ast);
        var usages = this.getUsages(ast);
        return imports.concat(usages);
    };
    Rule.prototype.getImports = function (ast) {
        var _this = this;
        return tsquery_1.tsquery(ast, CREATE_COMPONENT_IMPORT_QUERY).map(function (result) {
            var replacement = new tslint_1.Replacement(result.getStart(), result.getWidth(), RENDER);
            var start = result.getStart();
            var end = result.getEnd();
            return new tslint_1.RuleFailure(ast, start, end, FAILURE_MESSAGE, _this.ruleName, replacement);
        });
    };
    Rule.prototype.getUsages = function (ast) {
        var _this = this;
        return tsquery_1.tsquery(ast, CREATE_COMPONENT_CALL_EXPRESSION_QUERY).map(function (result) {
            var replacement = new tslint_1.Replacement(result.getStart(), result.getWidth(), RENDER);
            var start = result.getStart();
            var end = result.getEnd();
            return new tslint_1.RuleFailure(ast, start, end, FAILURE_MESSAGE, _this.ruleName, replacement);
        });
    };
    return Rule;
}(tslint_1.Rules.AbstractRule));
exports.Rule = Rule;
//# sourceMappingURL=noCreateComponentRule.js.map