"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
Object.defineProperty(exports, "__esModule", { value: true });
var schematics_1 = require("@angular-devkit/schematics");
var tasks_1 = require("@angular-devkit/schematics/tasks");
var path = require("path");
var literals_1 = require("@angular-devkit/core/src/utils/literals");
function createRule(ruleName) {
    var _a;
    return new tasks_1.TslintFixTask({
        rulesDirectory: path.join(__dirname, 'rules'),
        rules: (_a = {},
            _a[ruleName] = [true],
            _a),
    }, {
        includes: ['**/*.spec.ts', '**/*.test.ts'],
        silent: false,
    });
}
function displayInformation(tree, context) {
    context.logger.info(literals_1.stripIndents(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n    @angular-extensions/testing-library has moved to @testing-library/angular.\n\n    Learn more about this change here: https://github.com/testing-library/dom-testing-library/issues/260\n  "], ["\n    @angular-extensions/testing-library has moved to @testing-library/angular.\n\n    Learn more about this change here: https://github.com/testing-library/dom-testing-library/issues/260\n  "]))));
    return tree;
}
function updatePackageJson(host) {
    if (host.exists('package.json')) {
        var sourceText = host.read('package.json').toString('utf-8');
        var json = JSON.parse(sourceText);
        if (json['devDependencies'] && json['devDependencies']['@angular-extensions/testing-library']) {
            json['devDependencies']['@testing-library/angular'] = '^6.0.0';
            delete json['devDependencies']['@angular-extensions/testing-library'];
            host.overwrite('package.json', JSON.stringify(json, null, 2));
        }
    }
    return host;
}
function default_1() {
    return function (host, context) {
        context.addTask(createRule('no-angular-extensions-import'));
        return schematics_1.chain([displayInformation, updatePackageJson])(host, context);
    };
}
exports.default = default_1;
var templateObject_1;
//# sourceMappingURL=index.js.map