"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var tslint_1 = require("tslint");
var tsquery_1 = require("@phenomnomnominal/tsquery");
var IMPORT_QUERY = "ImportDeclaration StringLiteral[value=\"@angular-extensions/testing-library\"]";
var FAILURE_MESSAGE = 'Found the library `@angular-extensions/testing-library`, use `@testing-library/angular` instead.';
var Rule = (function (_super) {
    __extends(Rule, _super);
    function Rule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Rule.prototype.apply = function (ast) {
        var imports = this.getImports(ast);
        return imports;
    };
    Rule.prototype.getImports = function (ast) {
        var _this = this;
        return tsquery_1.tsquery(ast, IMPORT_QUERY).map(function (result) {
            var replacement = new tslint_1.Replacement(result.getStart() + 1, result.getWidth() - 2, '@testing-library/angular');
            var start = result.getStart();
            var end = result.getEnd();
            return new tslint_1.RuleFailure(ast, start, end, FAILURE_MESSAGE, _this.ruleName, replacement);
        });
    };
    return Rule;
}(tslint_1.Rules.AbstractRule));
exports.Rule = Rule;
//# sourceMappingURL=noAngularExtensionsImportRule.js.map